• Home
  • Line#
  • Scopes#
  • Navigate#
  • Raw
  • Download
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
11#
12# vmlinux
13#   ^
14#   |
15#   +--< $(KBUILD_VMLINUX_OBJS)
16#   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17#   |
18#   +--< $(KBUILD_VMLINUX_LIBS)
19#   |    +--< lib/lib.a + more
20#   |
21#   +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
37# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
41	printf "  %-7s %s\n" "${1}" "${2}"
42}
43
44# Generate a linker script to ensure correct ordering of initcalls.
45gen_initcalls()
46{
47	info GEN .tmp_initcalls.lds
48
49	${PYTHON} ${srctree}/scripts/jobserver-exec		\
50	${PERL} ${srctree}/scripts/generate_initcall_order.pl	\
51		${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}	\
52		> .tmp_initcalls.lds
53}
54
55# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
56# .tmp_symversions.lds
57gen_symversions()
58{
59	info GEN .tmp_symversions.lds
60	rm -f .tmp_symversions.lds
61
62	for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
63		if [ -f ${o}.symversions ]; then
64			cat ${o}.symversions >> .tmp_symversions.lds
65		fi
66	done
67}
68
69# Link of vmlinux.o used for section mismatch analysis
70# ${1} output file
71modpost_link()
72{
73	local objects
74	local lds=""
75
76	objects="--whole-archive				\
77		${KBUILD_VMLINUX_OBJS}				\
78		--no-whole-archive				\
79		--start-group					\
80		${KBUILD_VMLINUX_LIBS}				\
81		--end-group"
82
83	if [ -n "${CONFIG_LTO_CLANG}" ]; then
84		gen_initcalls
85		lds="-T .tmp_initcalls.lds"
86
87		if [ -n "${CONFIG_MODVERSIONS}" ]; then
88			gen_symversions
89			lds="${lds} -T .tmp_symversions.lds"
90		fi
91
92		# This might take a while, so indicate that we're doing
93		# an LTO link
94		info LTO ${1}
95	else
96		info LD ${1}
97	fi
98
99	${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
100}
101
102objtool_link()
103{
104	local objtoolcmd;
105	local objtoolopt;
106
107	if [ "${CONFIG_LTO_CLANG} ${CONFIG_STACK_VALIDATION}" = "y y" ]; then
108		# Don't perform vmlinux validation unless explicitly requested,
109		# but run objtool on vmlinux.o now that we have an object file.
110		if [ -n "${CONFIG_UNWINDER_ORC}" ]; then
111			objtoolcmd="orc generate"
112		fi
113
114		objtoolopt="${objtoolopt} --duplicate"
115
116		if [ -n "${CONFIG_FTRACE_MCOUNT_USE_OBJTOOL}" ]; then
117			objtoolopt="${objtoolopt} --mcount"
118		fi
119	fi
120
121	if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
122		objtoolopt="${objtoolopt} --noinstr"
123		if is_enabled CONFIG_CPU_UNRET_ENTRY; then
124			objtoolopt="${objtoolopt} --unret"
125		fi
126	fi
127
128	if [ -n "${objtoolopt}" ]; then
129		if [ -z "${objtoolcmd}" ]; then
130			objtoolcmd="check"
131		fi
132		objtoolopt="${objtoolopt} --vmlinux"
133		if [ -z "${CONFIG_FRAME_POINTER}" ]; then
134			objtoolopt="${objtoolopt} --no-fp"
135		fi
136		if [ -n "${CONFIG_GCOV_KERNEL}" ] || [ -n "${CONFIG_LTO_CLANG}" ]; then
137			objtoolopt="${objtoolopt} --no-unreachable"
138		fi
139		if [ -n "${CONFIG_RETPOLINE}" ]; then
140			objtoolopt="${objtoolopt} --retpoline"
141		fi
142		if [ -n "${CONFIG_X86_SMAP}" ]; then
143			objtoolopt="${objtoolopt} --uaccess"
144		fi
145		if [ -n "${CONFIG_SLS}" ]; then
146			objtoolopt="${objtoolopt} --sls"
147		fi
148		info OBJTOOL ${1}
149		tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
150	fi
151}
152
153# Link of vmlinux
154# ${1} - output file
155# ${2}, ${3}, ... - optional extra .o files
156vmlinux_link()
157{
158	local output=${1}
159	local objs
160	local libs
161	local ld
162	local ldflags
163	local ldlibs
164
165	info LD ${output}
166
167	# skip output file argument
168	shift
169
170	if [ -n "${CONFIG_LTO_CLANG}" ]; then
171		# Use vmlinux.o instead of performing the slow LTO link again.
172		objs=vmlinux.o
173		libs=
174	else
175		objs="${KBUILD_VMLINUX_OBJS}"
176		libs="${KBUILD_VMLINUX_LIBS}"
177	fi
178
179	if [ "${SRCARCH}" = "um" ]; then
180		wl=-Wl,
181		ld="${CC}"
182		ldflags="${CFLAGS_vmlinux}"
183		ldlibs="-lutil -lrt -lpthread"
184	else
185		wl=
186		ld="${LD}"
187		ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
188		ldlibs=
189	fi
190
191	ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
192
193	# The kallsyms linking does not need debug symbols included.
194	if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
195		ldflags="${ldflags} ${wl}--strip-debug"
196	fi
197
198	if [ -n "${CONFIG_VMLINUX_MAP}" ]; then
199		ldflags="${ldflags} ${wl}-Map=${output}.map"
200	fi
201
202	${ld} ${ldflags} -o ${output}					\
203		${wl}--whole-archive ${objs} ${wl}--no-whole-archive	\
204		${wl}--start-group ${libs} ${wl}--end-group		\
205		$@ ${ldlibs}
206}
207
208# generate .BTF typeinfo from DWARF debuginfo
209# ${1} - vmlinux image
210# ${2} - file to dump raw BTF data into
211gen_btf()
212{
213	local pahole_ver
214
215	if ! [ -x "$(command -v ${PAHOLE})" ]; then
216		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
217		return 1
218	fi
219
220	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
221	if [ "${pahole_ver}" -lt "116" ]; then
222		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
223		return 1
224	fi
225
226	vmlinux_link ${1}
227
228	info "BTF" ${2}
229	LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
230
231	# Create ${2} which contains just .BTF section but no symbols. Add
232	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
233	# deletes all symbols including __start_BTF and __stop_BTF, which will
234	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
235	# objcopy warnings: "empty loadable segment detected at ..."
236	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
237		--strip-all ${1} ${2} 2>/dev/null
238	# Change e_type to ET_REL so that it can be used to link final vmlinux.
239	# GNU ld 2.35+ and lld do not allow an ET_EXEC input.
240	if [ -n "${CONFIG_CPU_BIG_ENDIAN}" ]; then
241		et_rel='\0\1'
242	else
243		et_rel='\1\0'
244	fi
245	printf "${et_rel}" | dd of=${2} conv=notrunc bs=1 seek=16 status=none
246}
247
248# Create ${2} .S file with all symbols from the ${1} object file
249kallsyms()
250{
251	local kallsymopt;
252
253	if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
254		kallsymopt="${kallsymopt} --all-symbols"
255	fi
256
257	if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
258		kallsymopt="${kallsymopt} --absolute-percpu"
259	fi
260
261	if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
262		kallsymopt="${kallsymopt} --base-relative"
263	fi
264
265	info KSYMS ${2}
266	${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
267}
268
269# Perform one step in kallsyms generation, including temporary linking of
270# vmlinux.
271kallsyms_step()
272{
273	kallsymso_prev=${kallsymso}
274	kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
275	kallsymso=${kallsyms_vmlinux}.o
276	kallsyms_S=${kallsyms_vmlinux}.S
277
278	vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
279	kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
280
281	info AS ${kallsyms_S}
282	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
283	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
284	      -c -o ${kallsymso} ${kallsyms_S}
285}
286
287# Create map file with all symbols from ${1}
288# See mksymap for additional details
289mksysmap()
290{
291	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
292}
293
294sorttable()
295{
296	${objtree}/scripts/sorttable ${1}
297}
298
299# Delete output files in case of error
300cleanup()
301{
302	rm -f .btf.*
303	rm -f .tmp_System.map
304	rm -f .tmp_initcalls.lds
305	rm -f .tmp_symversions.lds
306	rm -f .tmp_vmlinux*
307	rm -f System.map
308	rm -f vmlinux
309	rm -f vmlinux.map
310	rm -f vmlinux.o
311	rm -f .vmlinux.d
312}
313
314# Use "make V=1" to debug this script
315case "${KBUILD_VERBOSE}" in
316*1*)
317	set -x
318	;;
319esac
320
321if [ "$1" = "clean" ]; then
322	cleanup
323	exit 0
324fi
325
326# We need access to CONFIG_ symbols
327. include/config/auto.conf
328
329# Update version
330info GEN .version
331if [ -r .version ]; then
332	VERSION=$(expr 0$(cat .version) + 1)
333	echo $VERSION > .version
334else
335	rm -f .version
336	echo 1 > .version
337fi;
338
339# final build of init/
340${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
341
342#link vmlinux.o
343modpost_link vmlinux.o
344objtool_link vmlinux.o
345
346# modpost vmlinux.o to check for section mismatches
347${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
348
349info MODINFO modules.builtin.modinfo
350${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
351info GEN modules.builtin
352# The second line aids cases where multiple modules share the same object.
353tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
354	tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
355
356btf_vmlinux_bin_o=""
357if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
358	btf_vmlinux_bin_o=.btf.vmlinux.bin.o
359	if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
360		echo >&2 "Failed to generate BTF for vmlinux"
361		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
362		exit 1
363	fi
364fi
365
366kallsymso=""
367kallsymso_prev=""
368kallsyms_vmlinux=""
369if [ -n "${CONFIG_KALLSYMS}" ]; then
370
371	# kallsyms support
372	# Generate section listing all symbols and add it into vmlinux
373	# It's a three step process:
374	# 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
375	#     but __kallsyms is empty.
376	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
377	#     the right size
378	# 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
379	#     the right size, but due to the added section, some
380	#     addresses have shifted.
381	#     From here, we generate a correct .tmp_kallsyms2.o
382	# 3)  That link may have expanded the kernel image enough that
383	#     more linker branch stubs / trampolines had to be added, which
384	#     introduces new names, which further expands kallsyms. Do another
385	#     pass if that is the case. In theory it's possible this results
386	#     in even more stubs, but unlikely.
387	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
388	#     other bugs.
389	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
390	#
391	# a)  Verify that the System.map from vmlinux matches the map from
392	#     ${kallsymso}.
393
394	kallsyms_step 1
395	kallsyms_step 2
396
397	# step 3
398	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
399	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
400
401	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
402		kallsyms_step 3
403	fi
404fi
405
406vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
407
408# fill in BTF IDs
409if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
410	info BTFIDS vmlinux
411	${RESOLVE_BTFIDS} vmlinux
412fi
413
414if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
415	info SORTTAB vmlinux
416	if ! sorttable vmlinux; then
417		echo >&2 Failed to sort kernel tables
418		exit 1
419	fi
420fi
421
422info SYSMAP System.map
423mksysmap vmlinux System.map
424
425# step a (see comment above)
426if [ -n "${CONFIG_KALLSYMS}" ]; then
427	mksysmap ${kallsyms_vmlinux} .tmp_System.map
428
429	if ! cmp -s System.map .tmp_System.map; then
430		echo >&2 Inconsistent kallsyms data
431		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
432		exit 1
433	fi
434fi
435
436# For fixdep
437echo "vmlinux: $0" > .vmlinux.d
438